Overview | Package | Class | Tree | Deprecated | Index | Help
| Protege 3.4 rc2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.stanford.smi.protege.model
Interface KnowledgeBase

All Superinterfaces:
  Disposable

All Known Implementing Classes:
  DefaultKnowledgeBase

    public interface KnowledgeBase

extends Disposable

A container for frames. Frame creation is funneled through here.

Author:
  Ray Fergerson

Field Summary
`static int` | `MAXIMUM_CARDINALITY_UNBOUNDED`
`static int` | `UNLIMITED_MATCHES`

Method Summary
`void` | `addClsListener(Cls cls, ClsListener listener)` Add a listener for class events for a particular class
`void` | `addClsListener(ClsListener listener)` Add a listener for class events for all classes
`void` | `addDirectSuperclass(Cls cls, Cls superclass)`
`void` | `addDirectSuperslot(Slot slot, Slot superslot)`
`void` | `addDirectTemplateSlot(Cls cls, Slot slot)`
`void` | `addDirectType(Instance instance, Cls directType)`
`void` | `addFacetListener(Facet facet, FacetListener listener)` Add a listener for facet events for a particular facet
`void` | `addFacetListener(FacetListener listener)` Add a listener for facet events for all facets
`void` | `addFrameListener(Frame frame, FrameListener listener)` add a listener fro frame evnets for a particular frame
`void` | `addFrameListener(FrameListener listener)` add a listener for frame events for all frames
`void` | `addInstance(Instance instance, String name, Cls type, boolean isNew)`
`void` | `addInstanceListener(Instance instance, InstanceListener listener)`
`void` | `addInstanceListener(InstanceListener listener)`
`void` | `addJavaLoadPackage(String path)` This method requires some background information.
`void` | `addKnowledgeBaseListener(KnowledgeBaseListener listener)`
`void` | `addOwnSlotValue(Frame frame, Slot slot, Object value)`
`void` | `addServerProjectListener(ServerProjectListener listener)`
`void` | `addSlotListener(SlotListener listener)`
`void` | `addSlotListener(Slot slot, SlotListener listener)`
`void` | `addTemplateFacetValue(Cls cls, Slot slot, Facet facet, Object value)`
`void` | `addTemplateSlotValue(Cls cls, Slot slot, Object value)`
`void` | `addTransactionListener(TransactionListener listener)`
`boolean` | `areValidOwnSlotValues(Frame frame, Slot slot, Collection values)`
`void` | `assertFrameName(Frame frame)`
`boolean` | `beginTransaction(String name)` Tells the system that one or more edit actions will follow which should be handled as a unit for undo.
`boolean` | `beginTransaction(String name, String appliedToFrameName)`
`void` | `clearAllListeners()`
`boolean` | `commitTransaction()` Commits the recently opened transaction
`boolean` | `containsFrame(String name)`
`Cls` | `createCls(FrameID id, Collection parents, Collection metaClses, boolean initializeDefaults)`
`Cls` | `createCls(String name, Collection parents)`
`Cls` | `createCls(String name, Collection parents, Cls metaCls)`
`Cls` | `createCls(String name, Collection parents, Cls metaCls, boolean initializeDefaults)`
`Facet` | `createFacet(String name)`
`Facet` | `createFacet(String name, Cls metaCls)`
`Facet` | `createFacet(String name, Cls metaCls, boolean initializeDefaults)`
`Instance` | `createInstance(FrameID id, Cls directType, boolean initializeDefaults)`
`Instance` | `createInstance(FrameID id, Collection directTypes, boolean initializeDefaults)`
`Instance` | `createInstance(String name, Cls directType)`
`Instance` | `createInstance(String name, Cls directType, boolean initializeDefaults)`
`Instance` | `createInstance(String name, Collection directTypes)`
`SimpleInstance` | `createSimpleInstance(FrameID id, Collection directTypes, boolean initializeDefaults)`
`Slot` | `createSlot(String name)`
`Slot` | `createSlot(String name, Cls metaCls)`
`Slot` | `createSlot(String name, Cls metaCls, boolean initializeDefaults)`
`Slot` | `createSlot(String name, Cls metaCls, Collection superslots, boolean initializeDefaults)`
`String` | `createUniqueFrameName(String name)` Deprecated. pass "null" in as a frame name to a create method to get a gensym name
`void` | `deleteCls(Cls cls)`
`void` | `deleteFacet(Facet facet)`
`void` | `deleteFrame(Frame frame)`
`void` | `deleteInstance(Instance instance)`
`void` | `deleteSlot(Slot slot)`
`boolean` | `endTransaction()` Deprecated. Use #commitTransaction() Ends the recently opened transaction and commits the state.
`boolean` | `endTransaction(boolean doCommit)` Deprecated. Use #commitTransaction or #rollbackTransaction() Ends the recently opened transaction and commits or rollback based on doCommit value
`Collection<Frame>` | `executeQuery(Query q)`
`void` | `flushCache()`
`void` | `flushEvents()`
`Collection` | `getAllowedClses(Slot slot)`
`Collection` | `getAllowedParents(Slot slot)`
`Collection` | `getAllowedValues(Slot slot)`
`boolean` | `getAllowsMultipleValues(Slot slot)`
`Facet` | `getAssociatedFacet(Slot slot)`
`Slot` | `getAssociatedSlot(Facet facet)`
`String` | `getBrowserText(Instance instance)`
`String` | `getBuildString()` Returns a string that contains something like "build 840" that refers to the build of Protege in use when this kb was last saved.
`Object` | `getClientInformation(Object key)` Allows a programmer to hang arbitrary information on a kb and retrieve it later.
`Cls` | `getCls(String name)`
`int` | `getClsCount()`
`Collection` | `getClses()`
`Collection<Cls>` | `getClsesWithMatchingBrowserText(String s, Collection superclasses, int maxMatches)`
`Collection` | `getClsNameMatches(String s, int maxMatches)` Get classes whose name matches the give string.
`CommandManager` | `getCommandManager()`
`Collection` | `getCurrentUsers()`
`Cls` | `getDefaultClsMetaCls()` If no meta class is specified when a class is created the system uses the metaclass of the first specified parent.
`Cls` | `getDefaultFacetMetaCls()`
`Cls` | `getDefaultSlotMetaCls()`
`Collection` | `getDefaultValues(Slot slot)`
`BrowserSlotPattern` | `getDirectBrowserSlotPattern(Cls cls)`
`Collection` | `getDirectDomain(Slot slot)`
`int` | `getDirectInstanceCount(Cls cls)`
`Collection<Instance>` | `getDirectInstances(Cls cls)`
`Collection` | `getDirectlyOverriddenTemplateFacets(Cls cls, Slot slot)`
`Collection` | `getDirectlyOverriddenTemplateSlots(Cls cls)`
`Object` | `getDirectOwnSlotValue(Frame frame, Slot slot)`
`List` | `getDirectOwnSlotValues(Frame frame, Slot slot)`
`Set` | `getDirectOwnSlotValuesClosure(Frame frame, Slot slot)`
`int` | `getDirectSubclassCount(Cls cls)`
`Collection` | `getDirectSubclasses(Cls cls)`
`int` | `getDirectSubslotCount(Slot slot)`
`Collection` | `getDirectSubslots(Slot slot)`
`int` | `getDirectSuperclassCount(Cls cls)`
`Collection<Cls>` | `getDirectSuperclasses(Cls cls)`
`int` | `getDirectSuperslotCount(Slot slot)`
`Collection` | `getDirectSuperslots(Slot slot)`
`List` | `getDirectTemplateFacetValues(Cls cls, Slot slot, Facet facet)`
`Collection` | `getDirectTemplateSlots(Cls cls)`
`List` | `getDirectTemplateSlotValues(Cls cls, Slot slot)`
`Cls` | `getDirectType(Instance instance)`
`Collection` | `getDirectTypes(Instance instance)`
`boolean` | `getDispatchEventsEnabled()`
`Collection` | `getDocumentation(Frame frame)`
`Collection` | `getDomain(Slot slot)`
`boolean` | `getEventsEnabled()` Deprecated. Use #getGenerateEventsEnabled(boolean)
`Facet` | `getFacet(String name)`
`int` | `getFacetCount()`
`Collection` | `getFacets()`
`Frame` | `getFrame(FrameID id)`
`Frame` | `getFrame(String name)`
`int` | `getFrameCount()`
`FrameCounts` | `getFrameCounts()`
`String` | `getFrameCreationTimestamp(Frame frame)`
`String` | `getFrameCreator(Frame frame)`
`FrameFactory` | `getFrameFactory()`
`String` | `getFrameLastModificationTimestamp(Frame frame)`
`String` | `getFrameLastModifier(Frame frame)`
`Collection` | `getFrameNameMatches(String s, int maxMatches)`
`String` | `getFrameNamePrefix()`
`Collection<Frame>` | `getFrames()`
`FrameStoreManager` | `getFrameStoreManager()`
`List<FrameStore>` | `getFrameStores()` Returns a list of FrameStores available to the system.
`Collection` | `getFramesWithValue(Slot slot, Facet facet, boolean isTemplate, Object value)` Gets frames with a particular own/template slot/facet value.
`boolean` | `getGenerateEventsEnabled()`
`Instance` | `getInstance(String fullname)`
`int` | `getInstanceCount(Cls cls)`
`Collection<Instance>` | `getInstances()`
`Collection<Instance>` | `getInstances(Cls cls)`
`String` | `getInvalidFrameNameDescription(String s, Frame frame)`
`String` | `getInvalidOwnSlotValuesText(Frame frame, Slot slot, Collection values)`
`String` | `getInvalidOwnSlotValueText(Frame frame, Slot slot, Object value)`
`Slot` | `getInverseSlot(Slot slot)`
`KnowledgeBaseFactory` | `getKnowledgeBaseFactory()`
`Collection<Frame>` | `getMatchingFrames(Slot slot, Facet facet, boolean isTemplate, String matchString, int maxMatches)` Finds all occurances of a string in the knowledge base.
`Collection<Reference>` | `getMatchingReferences(String s, int maxReferences)`
`int` | `getMaximumCardinality(Slot slot)`
`Number` | `getMaximumValue(Slot slot)`
`int` | `getMinimumCardinality(Slot slot)`
`Number` | `getMinimumValue(Slot slot)`
`String` | `getName()`
`String` | `getName(Frame frame)`
`Slot` | `getNameSlot()`
`int` | `getNextFrameNumber()`
`Collection` | `getOverriddenTemplateFacets(Cls cls, Slot slot)`
`boolean` | `getOwnSlotAllowsMultipleValues(Frame frame, Slot slot)`
`Collection` | `getOwnSlotAndSubslotValues(Frame frame, Slot slot)`
`Collection` | `getOwnSlotDefaultValues(Frame frame, Slot slot)`
`Collection` | `getOwnSlotFacets(Frame frame, Slot slot)`
`Collection` | `getOwnSlotFacetValues(Frame frame, Slot slot, Facet facet)`
`Collection<Slot>` | `getOwnSlots(Frame frame)`
`Object` | `getOwnSlotValue(Frame frame, Slot slot)`
`int` | `getOwnSlotValueCount(Frame frame, Slot slot)`
`Collection` | `getOwnSlotValues(Frame frame, Slot slot)`
`ValueType` | `getOwnSlotValueType(Frame frame, Slot slot)`
`Project` | `getProject()`
`Collection` | `getReachableSimpleInstances(Collection roots)`
`Collection<Reference>` | `getReferences(Object o, int maxReferences)`
`Slot` | `getReifedRelationFromSlot()`
`Slot` | `getReifedRelationToSlot()`
`Cls` | `getReifiedRelationCls()`
`Cls` | `getRootCls()`
`Collection` | `getRootClses()`
`Cls` | `getRootClsMetaCls()`
`Cls` | `getRootFacetMetaCls()`
`Cls` | `getRootSlotMetaCls()`
`Collection` | `getRootSlots()`
`SimpleInstance` | `getSimpleInstance(String name)`
`int` | `getSimpleInstanceCount()`
`Slot` | `getSlot(String name)`
`int` | `getSlotCount()`
`Collection` | `getSlots()`
`String` | `getSlotValueLastModificationTimestamp(Frame frame, Slot slot, boolean isTemplate)`
`String` | `getSlotValueLastModifier(Frame frame, Slot slot, boolean isTemplate)`
`Collection` | `getSubclasses(Cls cls)`
`Collection` | `getSubslots(Slot slot)`
`Collection` | `getSuperclasses(Cls cls)`
`Collection` | `getSuperslots(Slot slot)`
`SystemFrames` | `getSystemFrames()`
`Collection` | `getTemplateFacets(Cls cls, Slot slot)`
`Object` | `getTemplateFacetValue(Cls cls, Slot slot, Facet facet)`
`Collection` | `getTemplateFacetValues(Cls cls, Slot slot, Facet facet)`
`Collection` | `getTemplateSlotAllowedClses(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotAllowedParents(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotAllowedValues(Cls cls, Slot slot)`
`boolean` | `getTemplateSlotAllowsMultipleValues(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotDefaultValues(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotDocumentation(Cls cls, Slot slot)`
`int` | `getTemplateSlotMaximumCardinality(Cls cls, Slot slot)`
`Number` | `getTemplateSlotMaximumValue(Cls cls, Slot slot)`
`int` | `getTemplateSlotMinimumCardinality(Cls cls, Slot slot)`
`Number` | `getTemplateSlotMinimumValue(Cls cls, Slot slot)`
`Collection` | `getTemplateSlots(Cls cls)`
`Object` | `getTemplateSlotValue(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotValues(Cls cls, Slot slot)`
`ValueType` | `getTemplateSlotValueType(Cls cls, Slot slot)`
`Collection` | `getUnreachableSimpleInstances(Collection roots)`
`String` | `getUserName()`
`boolean` | `getValueChecking()`
`Collection` | `getValues(Slot slot)`
`ValueType` | `getValueType(Slot slot)`
`String` | `getVersionString()`
`boolean` | `hasChanged()`
`boolean` | `hasDirectlyOverriddenTemplateFacet(Cls cls, Slot slot, Facet facet)`
`boolean` | `hasDirectlyOverriddenTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasDirectSuperclass(Cls cls, Cls superclass)`
`boolean` | `hasDirectSuperslot(Slot slot, Slot superslot)`
`boolean` | `hasDirectTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasDirectType(Instance instance, Cls cls)`
`boolean` | `hasInheritedTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasOverriddenTemplateFacet(Cls cls, Slot slot, Facet facet)`
`boolean` | `hasOverriddenTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasOwnSlot(Frame frame, Slot slot)`
`boolean` | `hasSlotValueAtSomeFrame(Slot slot)`
`boolean` | `hasSuperclass(Cls cls, Cls superclass)`
`boolean` | `hasSuperslot(Slot slot, Slot superslot)`
`boolean` | `hasTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasType(Instance instance, Cls cls)`
`void` | `insertFrameStore(FrameStore newFrameStore)` Inserts a new frame store into the front of the delegation chain.
`void` | `insertFrameStore(FrameStore newFrameStore, int position)` Inserts a new frame store into the delegation chain.
`boolean` | `isAbstract(Cls cls)`
`boolean` | `isAutoUpdatingFacetValues()`
`boolean` | `isCallCachingEnabled()`
`boolean` | `isClosed()`
`boolean` | `isClsMetaCls(Cls cls)`
`boolean` | `isDefaultClsMetaCls(Cls cls)`
`boolean` | `isDefaultFacetMetaCls(Cls cls)`
`boolean` | `isDefaultSlotMetaCls(Cls cls)`
`boolean` | `isFacetMetaCls(Cls cls)`
`boolean` | `isJournalingEnabled()`
`boolean` | `isLoading()`
`boolean` | `isMetaCls(Cls cls)`
`boolean` | `isSlotMetaCls(Cls cls)`
`boolean` | `isUndoEnabled()`
`boolean` | `isValidFrameName(String s, Frame frame)`
`boolean` | `isValidOwnSlotValue(Frame frame, Slot slot, Object value)`
`void` | `moveDirectOwnSlotValue(Frame frame, Slot slot, int from, int to)`
`void` | `moveDirectSubclass(Cls cls, Cls subclass, Cls afterclass)`
`void` | `moveDirectSubslot(Slot slot, Slot subslot, Slot afterSlot)`
`void` | `moveDirectTemplateSlot(Cls cls, Slot slot, int toIndex)`
`void` | `moveDirectType(Instance instance, Cls directType, int index)`
`void` | `notifyVisibilityChanged(Frame frame)`
`void` | `removeClsListener(Cls cls, ClsListener listener)`
`void` | `removeClsListener(ClsListener listener)`
`void` | `removeDirectSuperclass(Cls cls, Cls superclass)`
`void` | `removeDirectSuperslot(Slot slot, Slot superslot)`
`void` | `removeDirectTemplateSlot(Cls cls, Slot slot)`
`void` | `removeDirectType(Instance instance, Cls directType)`
`void` | `removeFacetListener(Facet facet, FacetListener listener)`
`void` | `removeFacetListener(FacetListener listener)`
`void` | `removeFrameListener(Frame frame, FrameListener listener)`
`void` | `removeFrameListener(FrameListener listener)`
`void` | `removeFrameStore(FrameStore frameStore)`
`void` | `removeInstanceListener(Instance instance, InstanceListener listener)`
`void` | `removeInstanceListener(InstanceListener listener)`
`void` | `removeJavaLoadPackage(String path)`
`void` | `removeKnowledgeBaseListener(KnowledgeBaseListener listener)`
`void` | `removeOwnSlotValue(Frame frame, Slot slot, Object value)`
`void` | `removeServerProjectListener(ServerProjectListener listener)`
`void` | `removeSlotListener(SlotListener listener)`
`void` | `removeSlotListener(Slot slot, SlotListener listener)`
`void` | `removeTemplateFacetOverrides(Cls cls, Slot slot)`
`void` | `removeTransactionListener(TransactionListener listener)`
`Frame` | `rename(Frame frame, String name)`
`boolean` | `rollbackTransaction()` Rolls back the recently opened transaction
`void` | `setAbstract(Cls cls, boolean isAbstract)`
`void` | `setAllowedClses(Slot slot, Collection clses)`
`void` | `setAllowedParents(Slot slot, Collection parents)`
`void` | `setAllowedValues(Slot slot, Collection values)`
`void` | `setAllowsMultipleValues(Slot slot, boolean allowsMultiple)`
`boolean` | `setArgumentCheckingEnabled(boolean enabled)`
`void` | `setAssociatedFacet(Slot slot, Facet facet)`
`void` | `setAssociatedSlot(Facet facet, Slot slot)`
`void` | `setAutoUpdateFacetValues(boolean b)` Deprecated. Use setModificationRecordUpdatingEnabled
`void` | `setBuildString(String s)`
`boolean` | `setCallCachingEnabled(boolean enabled)`
`void` | `setChanged(boolean b)`
`boolean` | `setChangeMonitorEnabled(boolean enabled)`
`boolean` | `setCleanDispatchEnabled(boolean enabled)`
`Object` | `setClientInformation(Object key, Object value)`
`void` | `setDefaultClsMetaCls(Cls cls)`
`void` | `setDefaultFacetMetaCls(Cls cls)`
`void` | `setDefaultSlotMetaCls(Cls cls)`
`void` | `setDefaultValues(Slot slot, Collection values)`
`void` | `setDirectBrowserSlot(Cls cls, Slot slot)`
`void` | `setDirectBrowserSlotPattern(Cls cls, BrowserSlotPattern pattern)`
`void` | `setDirectOwnSlotValues(Frame frame, Slot slot, Collection values)`
`Instance` | `setDirectType(Instance instance, Cls cls)`
`void` | `setDirectTypeOfSubclasses(Cls cls, Cls type)`
`void` | `setDirectTypeOfSubslots(Slot slot, Cls type)`
`Instance` | `setDirectTypes(Instance instance, Collection types)`
`boolean` | `setDispatchEventsEnabled(boolean enabled)`
`void` | `setDocumentation(Frame frame, Collection text)`
`void` | `setDocumentation(Frame frame, String text)`
`boolean` | `setEventsEnabled(boolean enabled)` Deprecated. Use #setGenerateEventsEnabled(boolean)
`boolean` | `setFacetCheckingEnabled(boolean enabled)`
`void` | `setFrameFactory(FrameFactory factory)`
`void` | `setFrameNamePrefix(String name)`
`void` | `setFrameNameValidator(FrameNameValidator validator)`
`boolean` | `setGenerateDeletingFrameEventsEnabled(boolean enabled)`
`boolean` | `setGenerateEventsEnabled(boolean enabled)`
`void` | `setInverseSlot(Slot slot, Slot inverseSlot)`
`boolean` | `setJournalingEnabled(boolean enabled)`
`void` | `setMaximumCardinality(Slot slot, int max)`
`void` | `setMaximumValue(Slot slot, Number max)`
`void` | `setMinimumCardinality(Slot slot, int max)`
`void` | `setMinimumValue(Slot slot, Number min)`
`boolean` | `setModificationRecordUpdatingEnabled(boolean b)`
`void` | `setName(String name)`
`void` | `setNextFrameNumber(int i)`
`void` | `setOwnSlotValues(Frame frame, Slot slot, Collection values)` same as #setDirectOwnSlotValues(Frame, Slot, Collection)
`void` | `setPollForEvents(boolean enabled)`
`void` | `setProject(Project project)`
`void` | `setTemplateFacetValue(Cls cls, Slot slot, Facet facet, Object value)`
`void` | `setTemplateFacetValues(Cls cls, Slot slot, Facet facet, Collection values)`
`void` | `setTemplateSlotAllowedClses(Cls cls, Slot slot, Collection values)`
`void` | `setTemplateSlotAllowedParents(Cls cls, Slot slot, Collection values)`
`void` | `setTemplateSlotAllowedValues(Cls cls, Slot slot, Collection values)`
`void` | `setTemplateSlotAllowsMultipleValues(Cls cls, Slot slot, boolean allowsMultiple)`
`void` | `setTemplateSlotDefaultValues(Cls cls, Slot slot, Collection values)`
`void` | `setTemplateSlotDocumentation(Cls cls, Slot slot, Collection docs)`
`void` | `setTemplateSlotDocumentation(Cls cls, Slot slot, String doc)`
`void` | `setTemplateSlotMaximumCardinality(Cls cls, Slot slot, int value)`
`void` | `setTemplateSlotMaximumValue(Cls cls, Slot slot, Number value)`
`void` | `setTemplateSlotMinimumCardinality(Cls cls, Slot slot, int value)`
`void` | `setTemplateSlotMinimumValue(Cls cls, Slot slot, Number value)`
`void` | `setTemplateSlotValue(Cls cls, Slot slot, Object value)`
`void` | `setTemplateSlotValues(Cls cls, Slot slot, Collection value)`
`void` | `setTemplateSlotValueType(Cls cls, Slot slot, ValueType type)`
`boolean` | `setUndoEnabled(boolean enabled)`
`void` | `setValueChecking(boolean b)` Checks every call that changes an own slot value that the new value is consistent with all facets.
`void` | `setValues(Slot slot, Collection values)`
`void` | `setValueType(Slot slot, ValueType type)`
`void` | `setVersionString(String s)`
`void` | `startJournaling(URI uri)`
`void` | `stopJournaling()`

Methods inherited from interface edu.stanford.smi.protege.util.Disposable
`dispose`

Field Detail

### MAXIMUM_CARDINALITY_UNBOUNDED

    static final int MAXIMUM_CARDINALITY_UNBOUNDED

See Also:
  Constant Field Values

### UNLIMITED_MATCHES

    static final int UNLIMITED_MATCHES

See Also:
  Constant Field Values

Method Detail

### addJavaLoadPackage

    void addJavaLoadPackage(String path)

  This method requires some background information. When Protege wants to create a simple instance in the kb it creates an instance of the java class "DefaultSimpleInstance". Programmers can subclass this class and give the subclass the name of a class in the kb. Then when protege wants to create an instance of the class in the kb it will instead make an instance of the programmers java class rather than DefaultSimpleInstance. In order for this to work the user must specify the package that their java class appears in. (The class file must also be in the plugins directory.) For example, consider a protege project with a class A. Now a programmer creates a subclass of model.DefaultSimpleInstance and calls it org.me.A. He puts this .class file in the plugins/org/me directory. (Presumably he creates the subclass this in order to add additional methods onto org.me.A to provide some sort of desired functionality. The desired behavior is that when the user creates an instance of the kb class A that the system will create an instance of org.me.A and put it in the kb. Then when the programmer queries the kb for "get me instances of A" he will get back instances which can be cast to org.me.A. So, what this method does is to tell the system what package to search to find the java class to create. When the system creates an instance of A it searches all the packages, in order, to find a java class with the name .A. If it finds one then it uses it to create an instance. If it doesn't find any matches then it creates an instance of DefaultSimpleInstance.

### addKnowledgeBaseListener

    void addKnowledgeBaseListener(KnowledgeBaseListener listener)

### areValidOwnSlotValues

    boolean areValidOwnSlotValues(Frame frame,
                                  Slot slot,
                                  Collection values)

### containsFrame

    boolean containsFrame(String name)

### createCls

    Cls createCls(String name,
                  Collection parents)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createCls

    Cls createCls(String name,
                  Collection parents,
                  Cls metaCls)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createCls

    Cls createCls(String name,
                  Collection parents,
                  Cls metaCls,
                  boolean initializeDefaults)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createCls

    Cls createCls(FrameID id,
                  Collection parents,
                  Collection metaClses,
                  boolean initializeDefaults)

  Parameters:
    `id` - Pass null to cause the system to generate an id
    `name` - Pass null to cause the system to generate a name

### createFacet

    Facet createFacet(String name)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createFacet

    Facet createFacet(String name,
                      Cls metaCls)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createFacet

    Facet createFacet(String name,
                      Cls metaCls,
                      boolean initializeDefaults)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createInstance

    Instance createInstance(String name,
                            Cls directType)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createInstance

    Instance createInstance(String name,
                            Collection directTypes)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createInstance

    Instance createInstance(String name,
                            Cls directType,
                            boolean initializeDefaults)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createInstance

    Instance createInstance(FrameID id,
                            Cls directType,
                            boolean initializeDefaults)

  Parameters:
    `id` - Pass null to cause the system to generate an id
    `name` - Pass null to cause the system to generate a name

### createInstance

    Instance createInstance(FrameID id,
                            Collection directTypes,
                            boolean initializeDefaults)

  Parameters:
    `id` - Pass null to cause the system to generate an id
    `name` - Pass null to cause the system to generate a name

### createSimpleInstance

    SimpleInstance createSimpleInstance(FrameID id,
                                        Collection directTypes,
                                        boolean initializeDefaults)

  Parameters:
    `id` - Pass null to cause the system to generate an id
    `name` - Pass null to cause the system to generate a name

### createSlot

    Slot createSlot(String name)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createSlot

    Slot createSlot(String name,
                    Cls metaCls)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createSlot

    Slot createSlot(String name,
                    Cls metaCls,
                    boolean initializeDefaults)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createSlot

    Slot createSlot(String name,
                    Cls metaCls,
                    Collection superslots,
                    boolean initializeDefaults)

  Parameters:
    `name` - Pass null to cause the system to generate a name

### createUniqueFrameName

    String createUniqueFrameName(String name)

  Deprecated. pass "null" in as a frame name to a create method to get a gensym name

### deleteCls

    void deleteCls(Cls cls)

### deleteFacet

    void deleteFacet(Facet facet)

### deleteFrame

    void deleteFrame(Frame frame)

### deleteInstance

    void deleteInstance(Instance instance)

### deleteSlot

    void deleteSlot(Slot slot)

### getBuildString

    String getBuildString()

  Returns a string that contains something like "build 840" that refers to the build of Protege in use when this kb was last saved. This string format is not reliable and may change.

### getClientInformation

    Object getClientInformation(Object key)

  Allows a programmer to hang arbitrary information on a kb and retrieve it later. This information is not persistent. Since all programmers share the same "client information space" we recommend that your "key" be your java.lang.Class object. If you want to store more than one piece of information then you can make your value a set (or a map). Thus the common usage would be:

             Map myGoodStuff = new HashMap();
             myGoodStuff.put("foo", "bar");
             kb.setClientInformation(myClass.class, myGoodStuff);
             // ... later
             Map myGoodStuff = (Map) kb.getClientInformation(myClass.class);

  Widget writers typically don't need this sort of thing but backend authors do because one instance of the backend may need to communicate information to another instance (the loader to the storer, for example). This is very similar to the "client property" feature on javax.swing.JComponent or the client information on MS Windows windows and it exists for the same reasons. It allows you to store anything you want.

### getCls

    Cls getCls(String name)

### getClsCount

    int getClsCount()

### getClses

    Collection getClses()

### getClsNameMatches

    Collection getClsNameMatches(String s,
                                 int maxMatches)

  Get classes whose name matches the give string. This string allows "*" for "match any sequence" of characters. The string is not a regular expression. The matching is case-insensitive.

### getDefaultClsMetaCls

    Cls getDefaultClsMetaCls()

  If no meta class is specified when a class is created the system uses the metaclass of the first specified parent. If no parent is specified, or if the parent is :THING then the system uses this metaclass.

### getDefaultFacetMetaCls

    Cls getDefaultFacetMetaCls()

### getDefaultSlotMetaCls

    Cls getDefaultSlotMetaCls()

### getFacet

    Facet getFacet(String name)

### getFacetCount

    int getFacetCount()

### getFacets

    Collection getFacets()

### getFrame

    Frame getFrame(String name)

### getSimpleInstance

    SimpleInstance getSimpleInstance(String name)

### getFrame

    Frame getFrame(FrameID id)

### getFrameCount

    int getFrameCount()

### getFrameCreationTimestamp

    String getFrameCreationTimestamp(Frame frame)

### getFrameCreator

    String getFrameCreator(Frame frame)

### getFrameLastModificationTimestamp

    String getFrameLastModificationTimestamp(Frame frame)

### getFrameLastModifier

    String getFrameLastModifier(Frame frame)

### getFrameNameMatches

    Collection getFrameNameMatches(String s,
                                   int maxMatches)

### getFrameNamePrefix

    String getFrameNamePrefix()

### getFrames

    Collection<Frame> getFrames()

### getFrameStoreManager

    FrameStoreManager getFrameStoreManager()

### getFramesWithValue

    Collection getFramesWithValue(Slot slot,
                                  Facet facet,
                                  boolean isTemplate,
                                  Object value)

  Gets frames with a particular own/template slot/facet value.

  Parameters:
    `slot` - The slot to use. Must not be null.
    `facet` - If null then the value parameter is a slot value. Otherwise it is a facet value.
    `isTemplate` - If true then the return value is a template slot/facet value.
    `value` - A value to match exactly. The type of the object can be one of those listed in the documentation for `Frame`
  Returns:
    Collection of frames.

### getInstance

    Instance getInstance(String fullname)

### getInstances

    Collection<Instance> getInstances()

### getInstances

    Collection<Instance> getInstances(Cls cls)

### getInvalidOwnSlotValuesText

    String getInvalidOwnSlotValuesText(Frame frame,
                                       Slot slot,
                                       Collection values)

### getInvalidOwnSlotValueText

    String getInvalidOwnSlotValueText(Frame frame,
                                      Slot slot,
                                      Object value)

### getKnowledgeBaseFactory

    KnowledgeBaseFactory getKnowledgeBaseFactory()

### getMatchingFrames

    Collection<Frame> getMatchingFrames(Slot slot,
                                        Facet facet,
                                        boolean isTemplate,
                                        String matchString,
                                        int maxMatches)

  Finds all occurances of a string in the knowledge base. This function searches all slot/facet values for the given slot and facet and looks for string values that match matchString. A string value is said to match matchString if the string value is a match for the regular expression given by matchString. In the interests of performance, there is some leeway in what exactly is meant by a match. For the in memory backends, the match is calculated using the java.util.regex.Pattern algorithm except that any occurance "*" in the matchString is replaced with ".*" (e.g. "*" matches anything). However, database backends use a variation of the database LIKE operator except that "*" (match everything in the getMatching frames sense) is mapped to "%" (match everything in the database sense).

  Parameters:
    `slot` - The slot to use. Must not be null.
    `facet` - If null then the matchString parameter is a slot value. Otherwise it is a facet value.
    `isTemplate` - If true then the return value is a template slot/facet value.
    `matchString` - The string to match on. The string can include wild cards. The matching is case insensitive.
    `maxMatches` - maximum number of matches. Use -1 to get all matches. Be careful though. If the use searches on "e" do you really want to return 1M frames?
  Returns:
    Collection of frames.

### getName

    String getName()

### getNextFrameNumber

    int getNextFrameNumber()

### getProject

    Project getProject()

### getReachableSimpleInstances

    Collection getReachableSimpleInstances(Collection roots)

### getReferences

    Collection<Reference> getReferences(Object o,
                                        int maxReferences)

  Returns:
    A collection of #Reference instances.

### getMatchingReferences

    Collection<Reference> getMatchingReferences(String s,
                                                int maxReferences)

### getClsesWithMatchingBrowserText

    Collection<Cls> getClsesWithMatchingBrowserText(String s,
                                                    Collection superclasses,
                                                    int maxMatches)

### getRootCls

    Cls getRootCls()

### getRootClses

    Collection getRootClses()

  Returns:
    ":THING" wrapped in a collection. A convenience method.

### getRootClsMetaCls

    Cls getRootClsMetaCls()

### getRootFacetMetaCls

    Cls getRootFacetMetaCls()

### getRootSlotMetaCls

    Cls getRootSlotMetaCls()

### getRootSlots

    Collection getRootSlots()

### getSlot

    Slot getSlot(String name)

### getSlotCount

    int getSlotCount()

### getSlots

    Collection getSlots()

### getSlotValueLastModificationTimestamp

    String getSlotValueLastModificationTimestamp(Frame frame,
                                                 Slot slot,
                                                 boolean isTemplate)

### getSlotValueLastModifier

    String getSlotValueLastModifier(Frame frame,
                                    Slot slot,
                                    boolean isTemplate)

### getSubclasses

    Collection getSubclasses(Cls cls)

### getUnreachableSimpleInstances

    Collection getUnreachableSimpleInstances(Collection roots)

### getUserName

    String getUserName()

### getVersionString

    String getVersionString()

  Returns:
    a string that contains something like "Version 1.6.2" that refers to the version of Protege in use when this kb was last saved. This string format is not reliable and may change.

### hasChanged

    boolean hasChanged()

### isAutoUpdatingFacetValues

    boolean isAutoUpdatingFacetValues()

### isClsMetaCls

    boolean isClsMetaCls(Cls cls)

### isDefaultClsMetaCls

    boolean isDefaultClsMetaCls(Cls cls)

### isDefaultFacetMetaCls

    boolean isDefaultFacetMetaCls(Cls cls)

### isDefaultSlotMetaCls

    boolean isDefaultSlotMetaCls(Cls cls)

### isFacetMetaCls

    boolean isFacetMetaCls(Cls cls)

### isLoading

    boolean isLoading()

### isSlotMetaCls

    boolean isSlotMetaCls(Cls cls)

### isUndoEnabled

    boolean isUndoEnabled()

### isValidOwnSlotValue

    boolean isValidOwnSlotValue(Frame frame,
                                Slot slot,
                                Object value)

### removeJavaLoadPackage

    void removeJavaLoadPackage(String path)

### removeKnowledgeBaseListener

    void removeKnowledgeBaseListener(KnowledgeBaseListener listener)

### setAutoUpdateFacetValues

    void setAutoUpdateFacetValues(boolean b)

  Deprecated. Use setModificationRecordUpdatingEnabled

### setModificationRecordUpdatingEnabled

    boolean setModificationRecordUpdatingEnabled(boolean b)

### setBuildString

    void setBuildString(String s)

### setChanged

    void setChanged(boolean b)

### setClientInformation

    Object setClientInformation(Object key,
                                Object value)

### setDefaultClsMetaCls

    void setDefaultClsMetaCls(Cls cls)

### setDefaultFacetMetaCls

    void setDefaultFacetMetaCls(Cls cls)

### setDefaultSlotMetaCls

    void setDefaultSlotMetaCls(Cls cls)

### getEventsEnabled

    boolean getEventsEnabled()

  Deprecated. Use #getGenerateEventsEnabled(boolean)

### setEventsEnabled

    boolean setEventsEnabled(boolean enabled)

  Deprecated. Use #setGenerateEventsEnabled(boolean)

### setUndoEnabled

    boolean setUndoEnabled(boolean enabled)

### getDispatchEventsEnabled

    boolean getDispatchEventsEnabled()

### setDispatchEventsEnabled

    boolean setDispatchEventsEnabled(boolean enabled)

### getGenerateEventsEnabled

    boolean getGenerateEventsEnabled()

### setGenerateEventsEnabled

    boolean setGenerateEventsEnabled(boolean enabled)

### setGenerateDeletingFrameEventsEnabled

    boolean setGenerateDeletingFrameEventsEnabled(boolean enabled)

### setPollForEvents

    void setPollForEvents(boolean enabled)

### setJournalingEnabled

    boolean setJournalingEnabled(boolean enabled)

### isJournalingEnabled

    boolean isJournalingEnabled()

### setArgumentCheckingEnabled

    boolean setArgumentCheckingEnabled(boolean enabled)

### setChangeMonitorEnabled

    boolean setChangeMonitorEnabled(boolean enabled)

### setCleanDispatchEnabled

    boolean setCleanDispatchEnabled(boolean enabled)

### setFacetCheckingEnabled

    boolean setFacetCheckingEnabled(boolean enabled)

### setFrameNamePrefix

    void setFrameNamePrefix(String name)

### setName

    void setName(String name)

### setNextFrameNumber

    void setNextFrameNumber(int i)

### setProject

    void setProject(Project project)

### setValueChecking

    void setValueChecking(boolean b)

  Checks every call that changes an own slot value that the new value is consistent with all facets. This checking is disabled by default. It can significately slow down the system but is useful for tracking down bugs in code that calls the api (both system and user code).

### setVersionString

    void setVersionString(String s)

### setFrameFactory

    void setFrameFactory(FrameFactory factory)

### addFrameListener

    void addFrameListener(Frame frame,
                          FrameListener listener)

  add a listener fro frame evnets for a particular frame

### addFrameListener

    void addFrameListener(FrameListener listener)

  add a listener for frame events for all frames

### removeFrameListener

    void removeFrameListener(Frame frame,
                             FrameListener listener)

### removeFrameListener

    void removeFrameListener(FrameListener listener)

### addOwnSlotValue

    void addOwnSlotValue(Frame frame,
                         Slot slot,
                         Object value)

### getDocumentation

    Collection getDocumentation(Frame frame)

### getName

    String getName(Frame frame)

### getOwnSlotAllowsMultipleValues

    boolean getOwnSlotAllowsMultipleValues(Frame frame,
                                           Slot slot)

### getOwnSlotAndSubslotValues

    Collection getOwnSlotAndSubslotValues(Frame frame,
                                          Slot slot)

### getOwnSlotDefaultValues

    Collection getOwnSlotDefaultValues(Frame frame,
                                       Slot slot)

### getOwnSlotFacets

    Collection getOwnSlotFacets(Frame frame,
                                Slot slot)

### getOwnSlotFacetValues

    Collection getOwnSlotFacetValues(Frame frame,
                                     Slot slot,
                                     Facet facet)

### getOwnSlots

    Collection<Slot> getOwnSlots(Frame frame)

### getOwnSlotValues

    Collection getOwnSlotValues(Frame frame,
                                Slot slot)

### getDirectOwnSlotValue

    Object getDirectOwnSlotValue(Frame frame,
                                 Slot slot)

### getDirectOwnSlotValues

    List getDirectOwnSlotValues(Frame frame,
                                Slot slot)

### getOwnSlotValue

    Object getOwnSlotValue(Frame frame,
                           Slot slot)

### getOwnSlotValueCount

    int getOwnSlotValueCount(Frame frame,
                             Slot slot)

### getOwnSlotValueType

    ValueType getOwnSlotValueType(Frame frame,
                                  Slot slot)

### hasOwnSlot

    boolean hasOwnSlot(Frame frame,
                       Slot slot)

### moveDirectOwnSlotValue

    void moveDirectOwnSlotValue(Frame frame,
                                Slot slot,
                                int from,
                                int to)

### removeOwnSlotValue

    void removeOwnSlotValue(Frame frame,
                            Slot slot,
                            Object value)

### setDocumentation

    void setDocumentation(Frame frame,
                          String text)

### setDocumentation

    void setDocumentation(Frame frame,
                          Collection text)

### setDirectOwnSlotValues

    void setDirectOwnSlotValues(Frame frame,
                                Slot slot,
                                Collection values)

### setOwnSlotValues

    void setOwnSlotValues(Frame frame,
                          Slot slot,
                          Collection values)

  same as #setDirectOwnSlotValues(Frame, Slot, Collection)

### notifyVisibilityChanged

    void notifyVisibilityChanged(Frame frame)

### addFacetListener

    void addFacetListener(FacetListener listener)

  Add a listener for facet events for all facets

### removeFacetListener

    void removeFacetListener(FacetListener listener)

### addFacetListener

    void addFacetListener(Facet facet,
                          FacetListener listener)

  Add a listener for facet events for a particular facet

### removeFacetListener

    void removeFacetListener(Facet facet,
                             FacetListener listener)

### addServerProjectListener

    void addServerProjectListener(ServerProjectListener listener)

### removeServerProjectListener

    void removeServerProjectListener(ServerProjectListener listener)

### getAssociatedSlot

    Slot getAssociatedSlot(Facet facet)

### setAssociatedSlot

    void setAssociatedSlot(Facet facet,
                           Slot slot)

### addClsListener

    void addClsListener(ClsListener listener)

  Add a listener for class events for all classes

### addClsListener

    void addClsListener(Cls cls,
                        ClsListener listener)

  Add a listener for class events for a particular class

### removeClsListener

    void removeClsListener(Cls cls,
                           ClsListener listener)

### removeClsListener

    void removeClsListener(ClsListener listener)

### addDirectSuperclass

    void addDirectSuperclass(Cls cls,
                             Cls superclass)

### removeDirectSuperclass

    void removeDirectSuperclass(Cls cls,
                                Cls superclass)

### addDirectTemplateSlot

    void addDirectTemplateSlot(Cls cls,
                               Slot slot)

### removeDirectTemplateSlot

    void removeDirectTemplateSlot(Cls cls,
                                  Slot slot)

### addTemplateFacetValue

    void addTemplateFacetValue(Cls cls,
                               Slot slot,
                               Facet facet,
                               Object value)

### addTemplateSlotValue

    void addTemplateSlotValue(Cls cls,
                              Slot slot,
                              Object value)

### getNameSlot

    Slot getNameSlot()

### getDirectInstanceCount

    int getDirectInstanceCount(Cls cls)

### getDirectInstances

    Collection<Instance> getDirectInstances(Cls cls)

### getDirectSubclassCount

    int getDirectSubclassCount(Cls cls)

### getDirectSubclasses

    Collection getDirectSubclasses(Cls cls)

### getDirectSuperclassCount

    int getDirectSuperclassCount(Cls cls)

### getDirectSuperclasses

    Collection<Cls> getDirectSuperclasses(Cls cls)

### getDirectTemplateFacetValues

    List getDirectTemplateFacetValues(Cls cls,
                                      Slot slot,
                                      Facet facet)

### getDirectTemplateSlots

    Collection getDirectTemplateSlots(Cls cls)

### getDirectTemplateSlotValues

    List getDirectTemplateSlotValues(Cls cls,
                                     Slot slot)

### getInstanceCount

    int getInstanceCount(Cls cls)

### getSimpleInstanceCount

    int getSimpleInstanceCount()

### getSuperclasses

    Collection getSuperclasses(Cls cls)

### getTemplateFacets

    Collection getTemplateFacets(Cls cls,
                                 Slot slot)

### getTemplateFacetValue

    Object getTemplateFacetValue(Cls cls,
                                 Slot slot,
                                 Facet facet)

### getTemplateFacetValues

    Collection getTemplateFacetValues(Cls cls,
                                      Slot slot,
                                      Facet facet)

### getTemplateSlotAllowedClses

    Collection getTemplateSlotAllowedClses(Cls cls,
                                           Slot slot)

### getTemplateSlotAllowedParents

    Collection getTemplateSlotAllowedParents(Cls cls,
                                             Slot slot)

### getTemplateSlotAllowedValues

    Collection getTemplateSlotAllowedValues(Cls cls,
                                            Slot slot)

### getTemplateSlotAllowsMultipleValues

    boolean getTemplateSlotAllowsMultipleValues(Cls cls,
                                                Slot slot)

### getTemplateSlotDefaultValues

    Collection getTemplateSlotDefaultValues(Cls cls,
                                            Slot slot)

### getTemplateSlotDocumentation

    Collection getTemplateSlotDocumentation(Cls cls,
                                            Slot slot)

### getTemplateSlotMaximumCardinality

    int getTemplateSlotMaximumCardinality(Cls cls,
                                          Slot slot)

### getTemplateSlotMaximumValue

    Number getTemplateSlotMaximumValue(Cls cls,
                                       Slot slot)

### getTemplateSlotMinimumCardinality

    int getTemplateSlotMinimumCardinality(Cls cls,
                                          Slot slot)

### getTemplateSlotMinimumValue

    Number getTemplateSlotMinimumValue(Cls cls,
                                       Slot slot)

### getTemplateSlots

    Collection getTemplateSlots(Cls cls)

### getTemplateSlotValue

    Object getTemplateSlotValue(Cls cls,
                                Slot slot)

### getTemplateSlotValues

    Collection getTemplateSlotValues(Cls cls,
                                     Slot slot)

### getTemplateSlotValueType

    ValueType getTemplateSlotValueType(Cls cls,
                                       Slot slot)

### hasDirectlyOverriddenTemplateFacet

    boolean hasDirectlyOverriddenTemplateFacet(Cls cls,
                                               Slot slot,
                                               Facet facet)

### hasDirectlyOverriddenTemplateSlot

    boolean hasDirectlyOverriddenTemplateSlot(Cls cls,
                                              Slot slot)

### getDirectlyOverriddenTemplateSlots

    Collection getDirectlyOverriddenTemplateSlots(Cls cls)

### getDirectlyOverriddenTemplateFacets

    Collection getDirectlyOverriddenTemplateFacets(Cls cls,
                                                   Slot slot)

### hasDirectSuperclass

    boolean hasDirectSuperclass(Cls cls,
                                Cls superclass)

### hasDirectSuperslot

    boolean hasDirectSuperslot(Slot slot,
                               Slot superslot)

### hasSuperslot

    boolean hasSuperslot(Slot slot,
                         Slot superslot)

### moveDirectSubslot

    void moveDirectSubslot(Slot slot,
                           Slot subslot,
                           Slot afterSlot)

### moveDirectTemplateSlot

    void moveDirectTemplateSlot(Cls cls,
                                Slot slot,
                                int toIndex)

### hasDirectTemplateSlot

    boolean hasDirectTemplateSlot(Cls cls,
                                  Slot slot)

### hasInheritedTemplateSlot

    boolean hasInheritedTemplateSlot(Cls cls,
                                     Slot slot)

### hasOverriddenTemplateSlot

    boolean hasOverriddenTemplateSlot(Cls cls,
                                      Slot slot)

### hasOverriddenTemplateFacet

    boolean hasOverriddenTemplateFacet(Cls cls,
                                       Slot slot,
                                       Facet facet)

### hasSuperclass

    boolean hasSuperclass(Cls cls,
                          Cls superclass)

### hasTemplateSlot

    boolean hasTemplateSlot(Cls cls,
                            Slot slot)

### isAbstract

    boolean isAbstract(Cls cls)

### isMetaCls

    boolean isMetaCls(Cls cls)

### moveDirectSubclass

    void moveDirectSubclass(Cls cls,
                            Cls subclass,
                            Cls afterclass)

### removeTemplateFacetOverrides

    void removeTemplateFacetOverrides(Cls cls,
                                      Slot slot)

### setAbstract

    void setAbstract(Cls cls,
                     boolean isAbstract)

### setDirectTypeOfSubclasses

    void setDirectTypeOfSubclasses(Cls cls,
                                   Cls type)

### setTemplateFacetValue

    void setTemplateFacetValue(Cls cls,
                               Slot slot,
                               Facet facet,
                               Object value)

### setTemplateFacetValues

    void setTemplateFacetValues(Cls cls,
                                Slot slot,
                                Facet facet,
                                Collection values)

### setTemplateSlotAllowedClses

    void setTemplateSlotAllowedClses(Cls cls,
                                     Slot slot,
                                     Collection values)

### setTemplateSlotAllowedParents

    void setTemplateSlotAllowedParents(Cls cls,
                                       Slot slot,
                                       Collection values)

### setTemplateSlotAllowedValues

    void setTemplateSlotAllowedValues(Cls cls,
                                      Slot slot,
                                      Collection values)

### setTemplateSlotAllowsMultipleValues

    void setTemplateSlotAllowsMultipleValues(Cls cls,
                                             Slot slot,
                                             boolean allowsMultiple)

### setTemplateSlotDefaultValues

    void setTemplateSlotDefaultValues(Cls cls,
                                      Slot slot,
                                      Collection values)

### setTemplateSlotDocumentation

    void setTemplateSlotDocumentation(Cls cls,
                                      Slot slot,
                                      String doc)

### setTemplateSlotDocumentation

    void setTemplateSlotDocumentation(Cls cls,
                                      Slot slot,
                                      Collection docs)

### setTemplateSlotMaximumCardinality

    void setTemplateSlotMaximumCardinality(Cls cls,
                                           Slot slot,
                                           int value)

### setTemplateSlotMaximumValue

    void setTemplateSlotMaximumValue(Cls cls,
                                     Slot slot,
                                     Number value)

### setTemplateSlotMinimumCardinality

    void setTemplateSlotMinimumCardinality(Cls cls,
                                           Slot slot,
                                           int value)

### setTemplateSlotMinimumValue

    void setTemplateSlotMinimumValue(Cls cls,
                                     Slot slot,
                                     Number value)

### setTemplateSlotValue

    void setTemplateSlotValue(Cls cls,
                              Slot slot,
                              Object value)

### setTemplateSlotValues

    void setTemplateSlotValues(Cls cls,
                               Slot slot,
                               Collection value)

### setTemplateSlotValueType

    void setTemplateSlotValueType(Cls cls,
                                  Slot slot,
                                  ValueType type)

### addInstance

    void addInstance(Instance instance,
                     String name,
                     Cls type,
                     boolean isNew)

### addInstanceListener

    void addInstanceListener(Instance instance,
                             InstanceListener listener)

### addInstanceListener

    void addInstanceListener(InstanceListener listener)

### removeInstanceListener

    void removeInstanceListener(Instance instance,
                                InstanceListener listener)

### removeInstanceListener

    void removeInstanceListener(InstanceListener listener)

### getBrowserText

    String getBrowserText(Instance instance)

### getDirectType

    Cls getDirectType(Instance instance)

### getDirectTypes

    Collection getDirectTypes(Instance instance)

### hasDirectType

    boolean hasDirectType(Instance instance,
                          Cls cls)

### hasType

    boolean hasType(Instance instance,
                    Cls cls)

### setDirectType

    Instance setDirectType(Instance instance,
                           Cls cls)

### setDirectTypes

    Instance setDirectTypes(Instance instance,
                            Collection types)

### addDirectSuperslot

    void addDirectSuperslot(Slot slot,
                            Slot superslot)

### addSlotListener

    void addSlotListener(Slot slot,
                         SlotListener listener)

### addSlotListener

    void addSlotListener(SlotListener listener)

### removeSlotListener

    void removeSlotListener(Slot slot,
                            SlotListener listener)

### removeSlotListener

    void removeSlotListener(SlotListener listener)

### getAllowedClses

    Collection getAllowedClses(Slot slot)

### getAllowedParents

    Collection getAllowedParents(Slot slot)

### getAllowedValues

    Collection getAllowedValues(Slot slot)

### getAllowsMultipleValues

    boolean getAllowsMultipleValues(Slot slot)

### getAssociatedFacet

    Facet getAssociatedFacet(Slot slot)

### getDefaultValues

    Collection getDefaultValues(Slot slot)

### getDirectSubslotCount

    int getDirectSubslotCount(Slot slot)

### getDirectSubslots

    Collection getDirectSubslots(Slot slot)

### getDirectSuperslots

    Collection getDirectSuperslots(Slot slot)

### getDirectSuperslotCount

    int getDirectSuperslotCount(Slot slot)

### getInverseSlot

    Slot getInverseSlot(Slot slot)

### getMaximumCardinality

    int getMaximumCardinality(Slot slot)

### getMaximumValue

    Number getMaximumValue(Slot slot)

### getMinimumCardinality

    int getMinimumCardinality(Slot slot)

### getMinimumValue

    Number getMinimumValue(Slot slot)

### getSubslots

    Collection getSubslots(Slot slot)

### getSuperslots

    Collection getSuperslots(Slot slot)

### getDirectDomain

    Collection getDirectDomain(Slot slot)

### getDomain

    Collection getDomain(Slot slot)

### getValues

    Collection getValues(Slot slot)

### getValueType

    ValueType getValueType(Slot slot)

### hasSlotValueAtSomeFrame

    boolean hasSlotValueAtSomeFrame(Slot slot)

### removeDirectSuperslot

    void removeDirectSuperslot(Slot slot,
                               Slot superslot)

### setAllowedClses

    void setAllowedClses(Slot slot,
                         Collection clses)

### setAllowedParents

    void setAllowedParents(Slot slot,
                           Collection parents)

### setAllowedValues

    void setAllowedValues(Slot slot,
                          Collection values)

### setAllowsMultipleValues

    void setAllowsMultipleValues(Slot slot,
                                 boolean allowsMultiple)

### setAssociatedFacet

    void setAssociatedFacet(Slot slot,
                            Facet facet)

### setDefaultValues

    void setDefaultValues(Slot slot,
                          Collection values)

### setDirectTypeOfSubslots

    void setDirectTypeOfSubslots(Slot slot,
                                 Cls type)

### setInverseSlot

    void setInverseSlot(Slot slot,
                        Slot inverseSlot)

### setMaximumCardinality

    void setMaximumCardinality(Slot slot,
                               int max)

### setMaximumValue

    void setMaximumValue(Slot slot,
                         Number max)

### setMinimumCardinality

    void setMinimumCardinality(Slot slot,
                               int max)

### setMinimumValue

    void setMinimumValue(Slot slot,
                         Number min)

### setValues

    void setValues(Slot slot,
                   Collection values)

### setValueType

    void setValueType(Slot slot,
                      ValueType type)

### getOverriddenTemplateFacets

    Collection getOverriddenTemplateFacets(Cls cls,
                                           Slot slot)

### getCurrentUsers

    Collection getCurrentUsers()

### beginTransaction

    boolean beginTransaction(String name)

  Tells the system that one or more edit actions will follow which should be handled as a unit for undo. Editing components should wrap set/add/remove calls to any resource in a `beginTransaction() - commitTransaction() or rollbackTransaction()` block.

  Parameters:
    `name` - the human-readable name of the following transaction
  Returns:
    true
  See Also:
    `endTransaction()`

### beginTransaction

    boolean beginTransaction(String name,
                             String appliedToFrameName)

### endTransaction

    boolean endTransaction()

  Deprecated. Use #commitTransaction() Ends the recently opened transaction and commits the state.

  Returns:
    true - if commit succeeds false - otherwise
  See Also:
    `beginTransaction(java.lang.String)`

### endTransaction

    boolean endTransaction(boolean doCommit)

  Deprecated. Use #commitTransaction or #rollbackTransaction() Ends the recently opened transaction and commits or rollback based on doCommit value

  Parameters:
    `doCommit` - true: commits transaction false: rolls back transaction
  Returns:
    true - if operation succeeded false - if operation failed

### commitTransaction

    boolean commitTransaction()

  Commits the recently opened transaction

  Returns:
    true - if commit suceeded false - otherwise
  See Also:
    `beginTransaction(java.lang.String)`

### rollbackTransaction

    boolean rollbackTransaction()

  Rolls back the recently opened transaction

  Returns:
    true - if rollback succeeded false - otherwise
  See Also:
    `beginTransaction(java.lang.String)`

### addDirectType

    void addDirectType(Instance instance,
                       Cls directType)

### removeDirectType

    void removeDirectType(Instance instance,
                          Cls directType)

### moveDirectType

    void moveDirectType(Instance instance,
                        Cls directType,
                        int index)

### getCommandManager

    CommandManager getCommandManager()

### setFrameNameValidator

    void setFrameNameValidator(FrameNameValidator validator)

### isValidFrameName

    boolean isValidFrameName(String s,
                             Frame frame)

### getInvalidFrameNameDescription

    String getInvalidFrameNameDescription(String s,
                                          Frame frame)

### setDirectBrowserSlot

    void setDirectBrowserSlot(Cls cls,
                              Slot slot)

### insertFrameStore

    void insertFrameStore(FrameStore newFrameStore,
                          int position)

  Inserts a new frame store into the delegation chain.

  Parameters:
    `newFrameStore` -
    `position` - Position in the frame store list to insert this frame store.

### insertFrameStore

    void insertFrameStore(FrameStore newFrameStore)

  Inserts a new frame store into the front of the delegation chain.

  Parameters:
    `newFrameStore` -

### removeFrameStore

    void removeFrameStore(FrameStore frameStore)

### getFrameStores

    List<FrameStore> getFrameStores()

  Returns a list of FrameStores available to the system. This includes both enabled and disabled frame stores.

  Returns:
    List of #FrameStore

### getFrameFactory

    FrameFactory getFrameFactory()

### getSystemFrames

    SystemFrames getSystemFrames()

### clearAllListeners

    void clearAllListeners()

### getFrameCounts

    FrameCounts getFrameCounts()

### setDirectBrowserSlotPattern

    void setDirectBrowserSlotPattern(Cls cls,
                                     BrowserSlotPattern pattern)

### getDirectBrowserSlotPattern

    BrowserSlotPattern getDirectBrowserSlotPattern(Cls cls)

### getDirectOwnSlotValuesClosure

    Set getDirectOwnSlotValuesClosure(Frame frame,
                                      Slot slot)

### setCallCachingEnabled

    boolean setCallCachingEnabled(boolean enabled)

### isCallCachingEnabled

    boolean isCallCachingEnabled()

### getValueChecking

    boolean getValueChecking()

### startJournaling

    void startJournaling(URI uri)

### stopJournaling

    void stopJournaling()

### flushCache

    void flushCache()

### flushEvents

    void flushEvents()
                     throws ProtegeException

  Throws:
    `ProtegeException`

### getReifiedRelationCls

    Cls getReifiedRelationCls()

### getReifedRelationFromSlot

    Slot getReifedRelationFromSlot()

### getReifedRelationToSlot

    Slot getReifedRelationToSlot()

### isClosed

    boolean isClosed()

### addTransactionListener

    void addTransactionListener(TransactionListener listener)

### removeTransactionListener

    void removeTransactionListener(TransactionListener listener)

### executeQuery

    Collection<Frame> executeQuery(Query q)

### rename

    Frame rename(Frame frame,
                 String name)

### assertFrameName

    void assertFrameName(Frame frame)

Overview | Package | Class | Tree | Deprecated | Index | Help
| Protege 3.4 rc2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug report or feature request
Protégé is a trademark of Stanford University.
Copyright (c) 1998-2009 Stanford University.